
// C Source File
// Created 11/3/01; 4:16:29 PM


/*
///////////////////////////////////////////////////////////////////
											HUNGRY SNAKE
											by Ty Taylor
											
								Requires extgraph from tict.ticalc.org
										to compile			
///////////////////////////////////////////////////////////////////
*/



#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

#include "extgraph.h"




#define MAX_LENGTH 300
#define MAX_WORMS 30
#define MAX_BALLS 30


void slowdown(short j)
{
	short i;
	
	for(;j>0;j--){
	for(i=0;i<30000;i++);	
	}
	
}

struct playerworm
{
	unsigned char x[MAX_LENGTH], y[MAX_LENGTH];
	short length;
	char dir;
	char speed, speedmax;
};

struct ball
{
	int x,y;
	char dir, speed, speedmax;
};



void clrgrayscr()
{	
	SetPlane(0);
	clrscr();
	SetPlane(1);
	clrscr();
}
	
void drawgraypix(int x, int y, int color)
{
/*
	if(color==2)
	{
	SetPlane(0);
	DrawPix(x,y,2);		
	}

	SetPlane(1);
	DrawPix(x,y,2);
*/
//don't draw off the screen
if(x<0||y<0||x>159||y>99) return;

	
	EXT_XORPIX(GetPlane(1),x,y);
	if(color==2)	EXT_XORPIX(GetPlane(0),x,y);
		
		
}


int checkpix(int x, int y)
{
if(EXT_GETPIX(GetPlane(1),x,y)||y>99||y<1||x>159||x<1) return TRUE;
return FALSE;
}

void drawint(int num,int x, int y)
{
	char temp[15];
	sprintf(temp,"%d",num);
	DrawStr(x,y,temp,2);
}

int changenum(int *num, int x, int y)
	{
		int i,key;
		char temp1[15];
		
		DrawStr(x-8,y,">",4);
		do
		{
		key=ngetchx();
			
			if(key>='0'&&key<='9'&& *(num) < 10000)
			{
				
				*(num)*=10; 
				*(num)+=key-48;
				i++;
				
				sprintf(temp1,"%d   ",*(num));
				DrawStr(x,y,temp1,4);
			}
			
			if(key== KEY_BACKSPACE)
			{
				*(num)/=10;
				sprintf(temp1,"%d   ",*(num));
				DrawStr(x,y,temp1,4);
			}
			
		
			
			
		}while(key!=264&&key!=13);
		DrawStr(x-8,y," ",4);
	return key;
		
	}


void drawfood(int *food)
{	
	//draw food
	drawgraypix(*(food),*(food+1),2);
	drawgraypix(*(food+2),*(food+3),2);
	drawgraypix(*(food+4),*(food+5),2);
	drawgraypix(*(food+6),*(food+7),2);
}

void definefood(int *food)
{
	//define food
	do{
	*(food)=rand()%158+1;
	*(food+1)=rand()%98+1;
	}while(checkpix(*(food),*(food+1))||checkpix(*(food),*(food+1)+1)
	||checkpix(*(food)+1,*(food+1))||checkpix(*(food)+1,*(food+1)+1));
	
	*(food+2)=*(food);
	*(food+3)=*(food+1)+1;
	*(food+4)=*(food)+1;
	*(food+5)=*(food+1);
	*(food+6)=*(food)+1;
	*(food+7)=*(food+1)+1;	
}


void drawball(int x, int y)
{
	drawgraypix(x+1,y,2);
	drawgraypix(x+1,y+1,2);
	drawgraypix(x,y+1,2);
	drawgraypix(x+1,y+2,2);
	drawgraypix(x+2,y+1,2);	
}

int checkball(int x, int y)
{
	if(checkpix(x+1,y)|| 
	checkpix(x,y+1)||
	checkpix(x+1,y+2)||
	checkpix(x+2,y+1)||	
	checkpix(x+1,y+1)) return TRUE;
	return FALSE;
	
}



// Main Function
void _main(void)
{
	void *kbq = kbd_queue ();
	unsigned short key=0;
	int i=0,j=0,color=0;
	int food[4][2]={{}};
	int deathcounter;
	int exit=0;
	int gamespeed=150;
	int wormnum=10;
	int yourspeed=1;
	int lives=5;
	int level=0;
	int foodquota=10;
	int score=0;
	int avglength=30;
	int difficulty=2;
	static int highscore=0;
	int foodeat=0;
	int ballnum=5;
	int countdown=0;
	int playmode=0;	//0 for 1 player, 1 for 2 player
	int playernum=0;
	
	struct playerworm (*player)=NULL;
	struct ball balls[MAX_BALLS]={};

unsigned char leveldata[113]=
{
	8,	//values for this level
	8,8,20,5,	//foodquota, num of snakes, avg length, ball num
	40,50,120,50,	//line coordinates
	12,
	10,10,20,8,
	20,50,140,50,
	80,20,80,80,	
	24,
	12,12,30,10,
	20,20,50,50,
	20,80,50,50,
	140,20,110,50,
	140,80,110,50,
	50,50,110,50,
	32,
	14,14,30,12,
	20,20,130,20,
	130,20,130,40,
	20,40,130,40,
	20,40,20,60,
	20,60,130,60,
	130,60,130,80,
	20,80,130,80,
	32,
	16,16,40,14,
	20,20,60,20,
	40,20,40,80,
	60,20,100,80,
	60,20,60,80,
	100,20,100,80,
	100,20,140,20,
	120,20,120,80
};



	
	
	clrscr();

FontSetSys(2);
DrawStr(32,0,"HUNGRY SNAKE",2);
FontSetSys(1);

DrawStr(44,12,"by Ty Taylor",2);
	
DrawStr(30,25,"F1: New Game",2);
DrawStr(30,35,"F2: Customize",2);
//DrawStr(30,45,"F3: 2 Player Mode",2);
DrawStr(30,55,"ESC: Quit",2);

DrawStr(50,80,"High Score",2);
drawint(highscore,68,90);
	
key=ngetchx();

clrscr();
	
if(key==KEY_ESC) return;

if(key==KEY_F3) key=KEY_F1;

if(key==KEY_F3)
{

printf("Make sure both calculators are linked together and on this screen\n");
printf("Press any key to make this calc player 1");

playernum=0;
playmode=1;

do{

if (!OSdequeue (&key, kbq))
  {
    	playernum=2;
    	LIO_SendData (&playernum, 2); 
    	playernum=1;
	}

LIO_RecvData (&playernum, 2, 1);

}while(playernum==0);

clrscr();     

}



if(key==KEY_F2){
level=-1;


	DrawStr(0,0,"Gamespeed?",2);	
	drawint(gamespeed,80,0);
	changenum(&gamespeed,80,0);

	DrawStr(0,10,"Yourspeed?",2);	
	drawint(yourspeed,80,10);
	changenum(&yourspeed,80,10);

	DrawStr(0,20,"Food Quota?",2);	
	drawint(foodquota,80,20);
	changenum(&foodquota,80,20);
	
	DrawStr(0,30,"# of Snakes?",2);	
	drawint(wormnum,80,30);
	changenum(&wormnum,80,30);
	
	DrawStr(0,40,"Avg length?",2);	
	drawint(avglength,80,40);
	changenum(&avglength,80,40);
	
	DrawStr(0,50,"# of Balls?",2);	
	drawint(ballnum,80,50);
	changenum(&ballnum,80,50);
	
	wormnum++;
	if(wormnum>MAX_WORMS) wormnum=MAX_WORMS;
	if(ballnum>MAX_BALLS) ballnum=MAX_BALLS;

}

if(key==KEY_F1)
{
	DrawStr(40,0,"New Game",2);
	
	DrawStr(0,20,"F1: Easy",2);
	DrawStr(0,30,"F2: Medium",2);
	DrawStr(0,40,"F3: Hard",2);
	
	key=ngetchx();

	if(key==KEY_F1)
	{
	difficulty=1;
	gamespeed=200;
	}
	
	if(key==KEY_F3)
	{
	difficulty=3;
	gamespeed=100;
	}

}

//worm structure
player = calloc (MAX_WORMS, sizeof(*player));

	
	GrayOn();	

startlevel:


clrgrayscr();		

foodeat=0;


if(level>=0){

foodquota=8;
wormnum=10;
avglength=20;


if(level<5){
j=0;
for(i=level;i>0;i--)
{
	j+=leveldata[j]+1;	
}

i=leveldata[j++];

foodquota=leveldata[j++];
wormnum=leveldata[j++];
avglength=leveldata[j++];
ballnum=leveldata[j++];

i-=4;

//draw lines
while(i>0)
{
	FastDrawGrayLine(leveldata[j],leveldata[j+1],leveldata[j+2],leveldata[j+3],8);
	j+=4;
	i-=4;	
}
}






	foodquota=(foodquota*difficulty)/2;
	wormnum=(wormnum*difficulty)/2;
	ballnum=(ballnum*difficulty)/2;
	
}



//your snake
	player[0].length=15;	
	player[0].speed=0;	
	player[0].speedmax=yourspeed+1;

	
	//define enemy worms
	for(i=1;i<wormnum;i++)
	{
		player[i].x[0]=rand()%159+1;
		player[i].y[0]=rand()%99+1;
		player[i].dir=rand()%4;
		player[i].length=rand()%avglength+rand()%avglength+1;	
		if(player[i].length>MAX_LENGTH) player[i].length=MAX_LENGTH;
		player[i].speed=0;
		player[i].speedmax=rand()%3+2;
	}
	
	//define tail of worms
	for(j=0;j<wormnum;j++){
	for(i=1;i<player[j].length;i++)
	{
	
	
	//if still on screen
	if(player[j].x[i-1]<=0) player[j].dir=3;
	if(player[j].y[i-1]<=0) player[j].dir=2;
	if(player[j].x[i-1]>=159) player[j].dir=1;
	if(player[j].y[i-1]>=99) player[j].dir=0;
	
		switch(player[j].dir)
		{
			case 0: player[j].x[i]=player[j].x[i-1]-1; player[j].y[i]=player[j].y[i-1]; break; //right
			case 1: player[j].y[i]=player[j].y[i-1]+1; player[j].x[i]=player[j].x[i-1];  break; //up
			case 2: player[j].x[i]=player[j].x[i-1]+1; player[j].y[i]=player[j].y[i-1];  break; //left
			case 3: player[j].y[i]=player[j].y[i-1]-1; player[j].x[i]=player[j].x[i-1];  break; //down
		}
	}
	}
	

	
	//define balls
	for(i=0;i<ballnum;i++)
	{
		do{
		balls[i].x=rand()%156+1;
		balls[i].y=rand()%96+1;
		}while(checkball(balls[i].x,balls[i].y));
		
		balls[i].dir=rand()%4;
		balls[i].speed=0;
		balls[i].speedmax=rand()%3+1;
		drawball(balls[i].x,balls[i].y);
	}
	
	
definefood(&food[0][0]);
drawfood(&food[0][0]);
	
color=1;
	//draw snakes
	for(j=1;j<wormnum;j++){
	for(i=0;i<player[j].length;i++)
	drawgraypix(player[j].x[i],player[j].y[i],color);
	}


countdown=1;

slowdown(8000);

	
	do{

//slow down
slowdown(gamespeed);

	
if(playmode==1)		//if 2 player mode
{
	
		if(playernum==1)
	{

	transmit(GetPlane(1), 3000); 

	}
	else
	{
	i=0;
	do{
	
	i=receive(GetPlane(1), 3000);

	}while(i!=3000);

	}

	
}




	if (!OSdequeue (&key, kbq))
  {
    if(key==KEY_LEFT&&player[0].dir!=0) player[0].dir=2;
    if(key==KEY_RIGHT&&player[0].dir!=2) player[0].dir=0;
    if(key==KEY_UP&&player[0].dir!=3) player[0].dir=1;
    if(key==KEY_DOWN&&player[0].dir!=1) player[0].dir=3;
     

//your snake is reborn
if(countdown==1){

countdown=0;
	
j=0;


	
	player[0].x[0]=80;
	
	i=2;
	do{
	player[0].y[0]=i;
	i++;
	}while(checkpix(player[0].x[0],i));
	
	player[0].dir=3;
	player[0].length-=10;

if(player[0].length<15) player[0].length=15;



	for(i=1;i<player[j].length;i++)
	{	
	//if still on screen
	if(player[j].x[i-1]<=0) player[j].dir=3;
	if(player[j].y[i-1]<=0) player[j].dir=2;
	if(player[j].x[i-1]>=159) player[j].dir=1;
	if(player[j].y[i-1]>=99) player[j].dir=0;
	
		switch(player[j].dir)
		{
			case 0: player[j].x[i]=player[j].x[i-1]-1; player[j].y[i]=player[j].y[i-1]; break; //right
			case 1: player[j].y[i]=player[j].y[i-1]+1; player[j].x[i]=player[j].x[i-1];  break; //up
			case 2: player[j].x[i]=player[j].x[i-1]+1; player[j].y[i]=player[j].y[i-1];  break; //left
			case 3: player[j].y[i]=player[j].y[i-1]-1; player[j].x[i]=player[j].x[i-1];  break; //down
		}
	}

	player[0].dir=3;

	for(i=0;i<player[j].length;i++)
	drawgraypix(player[j].x[i],player[j].y[i],2);

	DrawStr(0,0,"Lives:",2);
	drawint(lives,42,0);

	ngetchx();	
	DrawStr(0,0,"Lives:",2);
	drawint(lives,42,0);
}

  }


//only for first player does this stuff
if(playmode==0||playernum==1)
{
	


//move balls
for(j=0;j<ballnum;j++)
{
	balls[j].speed++;
	
	if(balls[j].speed>balls[j].speedmax)
	{
		balls[j].speed=0;


			drawball(balls[j].x,balls[j].y);


	switch(balls[j].dir)
	{
		case 0: balls[j].x++; balls[j].y--; break;	//ne
		case 1: balls[j].x--; balls[j].y--; break;	//nw
		case 2: balls[j].x--; balls[j].y++; break;	//sw
		case 3: balls[j].x++; balls[j].y++; break;	//se
	}
			
			//random direction when they bounce off
			
		if(checkpix(balls[j].x+1,balls[j].y))
		{
			balls[j].dir=rand()%2+2;
		}
		else if(checkpix(balls[j].x,balls[j].y+1))
		{
			balls[j].dir=rand()%2+3;
			if(balls[j].dir==4) balls[j].dir=0;
		}
		else if(checkpix(balls[j].x+2,balls[j].y+1))
		{
			balls[j].dir=rand()%2+1;
		}
		else if(checkpix(balls[j].x+1,balls[j].y+2))
		{
			balls[j].dir=rand()%2;
		}
		

			drawball(balls[j].x,balls[j].y);

		
	}
	
}






if(countdown>1) countdown--;



//move worms
for(j=0;j<wormnum;j++)
{

if(countdown>0&&j==0) continue;

player[j].speed++;


if(player[j].speed>=player[j].speedmax){

player[j].speed=0;

if(j==0) color=2;
else color=1;	


//remove last on tail
	drawgraypix(player[j].x[player[j].length-1],player[j].y[player[j].length-1],color);


//move each one back
for(i=player[j].length-1;i>0;i--)
{
	player[j].x[i]=player[j].x[i-1];
	player[j].y[i]=player[j].y[i-1];
}

deathcounter=0;
movesnake:
	
	if(player[j].dir==0) player[j].x[0]++;
	if(player[j].dir==1) player[j].y[0]--;
	if(player[j].dir==2) player[j].x[0]--;
	if(player[j].dir==3) player[j].y[0]++;



if(j==0) //if it is players worm
{

//check pixel
if(checkpix(player[j].x[0],player[j].y[0]))	
{

// check for food
if((player[j].x[0]==food[0][0]||player[j].x[0]==food[1][0]||player[j].x[0]==food[2][0]||player[j].x[0]==food[3][0])
&&(player[j].y[0]==food[0][1]||player[j].y[0]==food[1][1]||player[j].y[0]==food[2][1]||player[j].y[0]==food[3][1]))
{

drawfood(&food[0][0]);

foodquota--;
foodeat++;

//beat the level
if(foodquota<=0)
{
	DrawStr(59,30,"Victory",4);
	DrawStr(44,40,"You are full",4);
	DrawStr(50,60,"Score:",4);
	score+=(wormnum+level+avglength/5)*foodeat*(1000/(gamespeed+1));
	drawint(score,92,60);
	ngetchx();
	ngetchx();
	
	level++;
	lives++;
	goto startlevel;
}

	//move each one back
for(i=player[j].length-1;i<player[j].length+9;i++)
{
	player[j].x[i+1]=player[j].x[i];
	player[j].y[i+1]=player[j].y[i];
}
player[j].length+=10;


definefood(&food[0][0]);
drawfood(&food[0][0]);

	
}
else
{
lives--;

if(lives<=0)
{
exit=1;	//you are dead
DrawStr(50,60,"Score:",4);
drawint(score,92,60);	

}

	
	countdown=10;		//waits a while before you are reborn

	
		for(i=1;i<player[j].length;i++)
		drawgraypix(player[j].x[i],player[j].y[i],color);

	

	
}

}

}
else //enemy worms
{


//check pixel
if(checkpix(player[j].x[0],player[j].y[0])||(rand()%player[j].length/2==0)	//randomly changes direction too
)	//worm changes direction
{
deathcounter++;
	if(player[j].dir==0) player[j].x[0]--;
	if(player[j].dir==1) player[j].y[0]++;
	if(player[j].dir==2) player[j].x[0]++;
	if(player[j].dir==3) player[j].y[0]--;
	
	player[j].dir=rand()%4;

if(deathcounter<5)
goto movesnake;	


}

}

if(!(countdown>0&&j==0))
	drawgraypix(player[j].x[0],player[j].y[0],color);

}
}

}




	}while(key!=KEY_ESC&&exit==0);
	

clrgrayscr();

	GrayOff();

if(score>highscore)
highscore=score;

	
	free(player);

	
}
